/*

  STARTOVNI CISLO: 35
  SOUBORY:
    s35safety.bpr
    s35safety.cpp
    s35main.h
    s35main.cpp
    s35main.dfm
    s35gstart.h
    s35gstart.cpp
    s35gstart.dfm
    README.txt

*/


//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop

#include "s35main.h"
#include "s35gstart.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TmainForm *mainForm;





// ================================
// tela funkci

void initGame()
// inicializace nove hry
{
  int i, j;

  mainForm->ClientWidth = pole_size * SIZE_CTVEREC + 2*SIZE_OKRAJ;
  mainForm->ClientHeight = pole_size * SIZE_CTVEREC + 2*SIZE_OKRAJ + mainForm->tools->Height;

  for (i = 0; i <= pole_size; i++)
    for (j = 0; j <= pole_size; j++) {
      DRAW_CARA(i, j, i+1, j);
      DRAW_CARA(i, j, i, j+1);
    }
  REDRAW;
  hrac = COLOR_HRAC2;
  zmen_hrace(hrac);
  skore1 = skore2 = -1;
  zvys_skore(COLOR_HRAC1);
  zvys_skore(COLOR_HRAC2);
  sirek = 2 * pole_size * (pole_size + 1);

  last_x1 = last_y1 = last_x2 = 0;
  last_y2 = 1;
}

void drawLine(int x1, int y1, int x2, int y2, int width, TColor color)
{
  if (x1 == x2) {
    svisle[x1][y1].width = width;
    svisle[x1][y1].color = color;
  } else if (y1 == y2) {
    rovne[x1][y1].width = width;
    rovne[x1][y1].color = color;
  }
}

void drawZvyr(int x1, int y1, int x2, int y2, int zvyr)
{
  if (x1 == x2) {
    if (svisle[x1][y1].color == COLOR_HRAC1 ||
        svisle[x1][y1].color == COLOR_HRAC2 ||
        svisle[x1][y1].color == COLOR_SIRKA)
      return;
  } else {
    if (rovne[x1][y1].color == COLOR_HRAC1 ||
        rovne[x1][y1].color == COLOR_HRAC2 ||
        rovne[x1][y1].color == COLOR_SIRKA)
      return;
  }

  CANVAS->Pen->Width = WIDTH_ZVYRAZ;
  if (zvyr)
    CANVAS->Pen->Color = COLOR_ZVYRAZ;
  else
    CANVAS->Pen->Color = COLOR_BG;

  if (x1 == x2) {
    CANVAS->MoveTo(x1 * SIZE_CTVEREC + SIZE_OKRAJ, y1 * SIZE_CTVEREC + SIZE_OKRAJ +2);
    CANVAS->LineTo(x2 * SIZE_CTVEREC + SIZE_OKRAJ, y2 * SIZE_CTVEREC + SIZE_OKRAJ -2);
  } else {
    CANVAS->MoveTo(x1 * SIZE_CTVEREC + SIZE_OKRAJ +2, y1 * SIZE_CTVEREC + SIZE_OKRAJ);
    CANVAS->LineTo(x2 * SIZE_CTVEREC + SIZE_OKRAJ -2, y2 * SIZE_CTVEREC + SIZE_OKRAJ);
  }

  if (!zvyr) {
    CANVAS->Pen->Width = WIDTH_CARA;
    CANVAS->Pen->Color = COLOR_CARA;
    if (x1 == x2) {
      CANVAS->MoveTo(x1 * SIZE_CTVEREC + SIZE_OKRAJ, y1 * SIZE_CTVEREC + SIZE_OKRAJ +2);
      CANVAS->LineTo(x2 * SIZE_CTVEREC + SIZE_OKRAJ, y2 * SIZE_CTVEREC + SIZE_OKRAJ -2);
    } else {
      CANVAS->MoveTo(x1 * SIZE_CTVEREC + SIZE_OKRAJ +2, y1 * SIZE_CTVEREC + SIZE_OKRAJ);
      CANVAS->LineTo(x2 * SIZE_CTVEREC + SIZE_OKRAJ -2, y2 * SIZE_CTVEREC + SIZE_OKRAJ);
    }
  }
}

int blizkoCary(int x, int y, int &x1, int &y1, int &x2, int &y2)
{
  int i;

  x -= SIZE_OKRAJ;
  y -= SIZE_OKRAJ;

  for (i = x - VZDAL_ZVYRAZ; i <= x + VZDAL_ZVYRAZ; i++)
    if (CANVAS->Pixels[i+SIZE_OKRAJ][y+SIZE_OKRAJ] == COLOR_HRAC1 ||
        CANVAS->Pixels[i+SIZE_OKRAJ][y+SIZE_OKRAJ] == COLOR_HRAC2 ||
        CANVAS->Pixels[i+SIZE_OKRAJ][y+SIZE_OKRAJ] == COLOR_SIRKA)
      return 2;
    if (i % SIZE_CTVEREC == 0) {
      ZRUS_ZVYRAZ(x1, y1, x2, y2);
      x2 = x1 = i / SIZE_CTVEREC;
      y2 = 1 + (y1 = y / SIZE_CTVEREC);
      return 1;
    }

  for (i = y - VZDAL_ZVYRAZ; i <= y + VZDAL_ZVYRAZ; i++)
    if (CANVAS->Pixels[x+SIZE_OKRAJ][i+SIZE_OKRAJ] == COLOR_HRAC1 ||
        CANVAS->Pixels[x+SIZE_OKRAJ][i+SIZE_OKRAJ] == COLOR_HRAC2 ||
        CANVAS->Pixels[x+SIZE_OKRAJ][i+SIZE_OKRAJ] == COLOR_SIRKA)
      return 2;
    if (i % SIZE_CTVEREC == 0) {
      ZRUS_ZVYRAZ(x1, y1, x2, y2);
      y2 = y1 = i / SIZE_CTVEREC;
      x2 = 1 + (x1 = x / SIZE_CTVEREC);
      return 1;
    }

  return 0;
}

int ctver2(int x, int y)
{
  if (x > pole_size || y > pole_size)
    return 0;
    
  if (rovne[x][y].color != COLOR_CARA &&
      svisle[x][y].color != COLOR_CARA &&
      rovne[x][y+1].color != COLOR_CARA &&
      svisle[x+1][y].color != COLOR_CARA) {
    // hrac ziskal ctverec
    DRAW_SIRKA(x, y, x+1, y, hrac);
    DRAW_SIRKA(x, y, x, y+1, hrac);
    DRAW_SIRKA(x+1, y, x+1, y+1, hrac);
    DRAW_SIRKA(x, y+1, x+1, y+1, hrac);
    return 1;
  }
  return 0;
}

int ctverec(int x1, int y1, int x2, int y2)
{
  int ctv = 0;
  if (y1 == y2) { // ctverce nad sebou
    if (ctver2(x1, y1-1)) {
      zvys_skore(hrac);
      ctv = 1;
    }
    if (ctver2(x1, y1)) {
      zvys_skore(hrac);
      ctv = 1;
    }
  } else {      // ctverce vedle sebe
    if (ctver2(x1-1, y1)) {
      zvys_skore(hrac);
      ctv = 1;
    }
    if (ctver2(x1, y1)) {
      zvys_skore(hrac);
      ctv = 1;
    }
  }
  return ctv;
}

void zvys_skore(TColor hrac)
{
  if (hrac == COLOR_HRAC1)
    mainForm->skl1->Caption = IntToStr(++skore1);
  else
    mainForm->skl2->Caption = IntToStr(++skore2);
}

void zmen_hrace(TColor &hrac)
{
  if (hrac == COLOR_HRAC1) {
    mainForm->player->Font->Color = hrac = COLOR_HRAC2;
    mainForm->player->Caption = "Hr 2";
  } else {
    mainForm->player->Font->Color = hrac = COLOR_HRAC1;
    mainForm->player->Caption = "Hr 1";
  }
}



// ================================






//---------------------------------------------------------------------------
__fastcall TmainForm::TmainForm(TComponent* Owner)
        : TForm(Owner)
{
}
//---------------------------------------------------------------------------
void __fastcall TmainForm::Konec1Click(TObject *Sender)
{
  Close();
}
//---------------------------------------------------------------------------

void __fastcall TmainForm::Nov1Click(TObject *Sender)
{
  int mr = gstartForm->ShowModal();

  if (mr == mrOk) {
    pole_size = gstartForm->velikostSpin->Value;
    initGame();
  }
}
//---------------------------------------------------------------------------

void __fastcall TmainForm::polePaint(TObject *Sender)
{
  int x, y;

  for (x = 0; x <= pole_size; x++)
    for (y = 0; y <= pole_size; y++) {
      if (x < pole_size) {
        CANVAS->Pen->Width = rovne[x][y].width;
        CANVAS->Pen->Color = rovne[x][y].color;
        CANVAS->MoveTo(x * SIZE_CTVEREC + SIZE_OKRAJ +2, y * SIZE_CTVEREC + SIZE_OKRAJ);
        CANVAS->LineTo((x+1) * SIZE_CTVEREC + SIZE_OKRAJ -2, y * SIZE_CTVEREC + SIZE_OKRAJ);
      }
      if (y < pole_size) {
        CANVAS->Pen->Width = svisle[x][y].width;
        CANVAS->Pen->Color = svisle[x][y].color;
        CANVAS->MoveTo(x * SIZE_CTVEREC + SIZE_OKRAJ, y * SIZE_CTVEREC + SIZE_OKRAJ +2);
        CANVAS->LineTo(x * SIZE_CTVEREC + SIZE_OKRAJ, (y+1) * SIZE_CTVEREC + SIZE_OKRAJ -2);
      }
    }
}
//---------------------------------------------------------------------------

void __fastcall TmainForm::poleMouseMove(TObject *Sender,
      TShiftState Shift, int X, int Y)
{
  int bc = blizkoCary(X, Y, zvyr_x1, zvyr_y1, zvyr_x2, zvyr_y2);
  if (bc == 2)
    return;
  if (bc == 1) {
    DRAW_ZVYRAZ(zvyr_x1, zvyr_y1, zvyr_x2, zvyr_y2);
  }

}
//---------------------------------------------------------------------------

void __fastcall TmainForm::poleClick(TObject *Sender)
{
  if (zvyr_x1 != -1 && zvyr_y1 != -1 && zvyr_x2 != -1 && zvyr_y2 != -1) {
    last_x1 = zvyr_x1; last_y1 = zvyr_y1;
    last_x2 = zvyr_x2; last_y2 = zvyr_y2;
    DRAW_SIRKA(zvyr_x1, zvyr_y1, zvyr_x2, zvyr_y2, COLOR_SIRKA);
    sirek--;
    if (!ctverec(zvyr_x1, zvyr_y1, zvyr_x2, zvyr_y2)) {
      zmen_hrace(hrac);
    }
    REDRAW;
    zvyr_x1 = zvyr_y1 = zvyr_x2 = zvyr_y2 = -1;
    if (sirek == 0) {
      // hra je dokoncena
      if (skore1 > skore2)
        ShowMessage("Vyhrl hr 1!!");
      else if (skore1 < skore2)
        ShowMessage("Vyhrl hr 2!!");
      else
        ShowMessage("Hra skonila nerozhodn!!");
    }
  }
}
//---------------------------------------------------------------------------

void __fastcall TmainForm::FormCreate(TObject *Sender)
{
  initGame();
}
//---------------------------------------------------------------------------

void __fastcall TmainForm::FormKeyPress(TObject *Sender, char &Key)
{
  int i;

  if (zvyr_x1 == -1 && zvyr_y1 == -1 && zvyr_x2 == -1 && zvyr_y2 == -1) {
    zvyr_x1 = last_x1; zvyr_y1 = last_y1;
    zvyr_x2 = last_x2; zvyr_y2 = last_y2;
  } else {
    ZRUS_ZVYRAZ(zvyr_x1, zvyr_y1, zvyr_x2, zvyr_y2);
  }

  switch (Key) {
  case 13: pole->OnClick(Sender); break;
  case 52: zvyr_x1--; zvyr_x2--; break;
  case 54: zvyr_x1++; zvyr_x2++; break;
  case 56: zvyr_y1--; zvyr_y2--; break;
  case 50: zvyr_y1++; zvyr_y2++; break;
  }

  if (zvyr_y1 == zvyr_y2) {
    switch (Key) {
    case 55: zvyr_y1--; zvyr_x2--; break;
    case 57: zvyr_y1--; zvyr_x1++; break;
    case 49: zvyr_y2++; zvyr_x2--; break;
    case 51: zvyr_y2++; zvyr_x1++; break;
    }
  } else {
    switch (Key) {
    case 55: zvyr_x1--; zvyr_y2--; break;
    case 57: zvyr_y2--; zvyr_x2++; break;
    case 49: zvyr_y1++; zvyr_x1--; break;
    case 51: zvyr_y1++; zvyr_x2++; break;
    }
  }

  DRAW_ZVYRAZ(zvyr_x1, zvyr_y1, zvyr_x2, zvyr_y2);
}
//---------------------------------------------------------------------------

